
;	THE 'SAVE, LOAD, VERIFY & MERGE' COMMAND ROUTINES
;The entry point SAVE_ETC is used for all four commands. The value held in
;T_ADDR however distinguishes between the four commands. The 1st part of
;the following routine is concerned with the construction of the 'header
;information' in the work space.
L0605:;SAVE_ETC
	POP	AF		;Drop the addr - SCAN_LOOP.
	LD	A,(L5C74);T_ADDR_lo ;Reduce T_ADDR_lo by E0;
	SUB	0E0H		;giving 00 for SAVE, 01 for load,
	LD	(L5C74),A;T_ADDR_lo ;02 for VERIFY, 03 for MERGE.
	CALL	L1C8C;EXPT_EXP	;Pass the parameters of the 'name'
				;to the calculator stack.
	CALL	L2530;SYNTAX_Z	;Jump forward if checking
	JR	Z,L0652;SA_DATA	;syntax.
	LD	BC,11H		;Allow 17 locs
	LD	A,(L5C74);T_ADDR_lo ;for the header of a SAVE but
	AND	A		;34 for the other commands.
	JR	Z,L0621;SA_SPACE
	LD	C,22H
L0621:;SA_SPACE
	RST	30H;BC_SPACES	;The required amomount of space is
				;made in the work space.
	PUSH	DE		;Copy the start addr to the
	POP	IX		;IX reg pair.
	LD	B,0BH		;A program name can have
	LD	A,' '		;up to 10 chars but
L0629:;SA_BLANK
	LD	(DE),A		;1st enter 11 space
	INC	DE		;chars into the prepared
	DJNZ	L0629;SA_BLANK	;area.
	LD	(IX+1),0FFH	;A null name is FF only.
	CALL	L2BF1;STK_FETCH	;The parameters of the name are fetched
				;and its length is tested.
	LD	HL,0FFF6H	;This is '-10'.
	DEC	BC		;In effect jump forward if the
	ADD	HL,BC		;length of the name is not
	INC	BC		;too long. (i.e. No more than
	JR	NC,L064B;SA_NAME;10 chars.)
	LD	A,(L5C74);T_ADDR_lo ;But allow for the LOADing,
	AND	A		;VERIFYing and MERGEing of programs
	JR	NZ,L0644;SA_NULL;with 'null' names or extra long names.

;Report F - Invalid file name
L0642:;REPORT_F
	RST	8;ERROR_1	;Call the error handling
	DB	0EH		;routine.

;Continue to handle the name of the program.
L0644:;SA_NULL
	LD	A,B		;Jump forward if the name
	OR	C		;has a 'null' length.
	JR	Z,L0652;SA_DATA
	LD	BC,0AH		;But truncate longer names

;The name is now transferred to the work space (2nd loc onwards).
L064B:;SA_NAME
	PUSH	IX		;Copy the start addr to the
	POP	HL		;HL reg pair.
	INC	HL		;Step to the 2nd loc.
	EX	DE,HL		;Switch the pointers over and
	LDIR			;copy the name.

;The many different parameters, if any, that follow the command are now
;considered. Start by handling 'xxx "name" DATA'.
L0652:;SA_DATA
	RST	18H;GET_CHAR	;Is the present code the
	CP	0E4H		;token 'DATA'?
	JR	NZ,L06A0;SA_SCR$;Jump if not.
	LD	A,(L5C74);T_ADDR_lo ;However it is not possible
	CP	3		;to have 'MERGE name DATA'.
	JP	Z,L1C8A;REPORT_C
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L28B2;LOOK_VARS	;Look in the vars area for the array.
	SET	7,C		;Set bit 7 of the array's name.
	JR	NC,L0672;SA_V_OLD ;Jump if handling an existing array.
	LD	HL,0		;Signal 'using a new array'.
	LD	A,(L5C74);T_ADDR_lo ;Consider the value in T_ADDR
	DEC	A		;and give an error if trying to
	JR	Z,L0685;SA_V_NEW;SAVE or VERIFY a new array.

;Report 2 - Variable not found
	RST	8;ERROR_1	;Call the error handling
	DB	1		;routine.

;Continue with the handling of an existing array.
L0672:;SA_V_OLD
	JP	NZ,L1C8A;REPORT_C ;Note: This fails to exclude simple strings.
	CALL	L2530;SYNTAX_Z	;Jump forward if checking
	JR	Z,L0692;SA_DATA_1 ;syntax.
	INC	HL		;Point to the 'low length' of the var.
	LD	A,(HL)		;The low length byte goes into
	LD	(IX+0BH),A	;the work space; followed by
	INC	HL		;the high length byte.
	LD	A,(HL)
	LD	(IX+0CH),A
	INC	HL		;Step past the length byte.

;The next part is common to both 'old' and 'new' arrays.
;Note: Syntax path error.
L0685:;SA_V_NEW
	LD	(IX+0EH),C	;Copy the array's name.
	LD	A,1		;Assume an array of numbers.
	BIT	6,C		;Jump if it is so.
	JR	Z,L068F;SA_V_TYPE
	INC	A		;It is an array of chars.
L068F:;SA_V_TYPE
	LD	(IX+0),A	;Save the 'type' in the 1st loc
				;of the header area.

;The last part of the statement is examined before joining the other pathways.
L0692:;SA_DATA_1
	EX	DE,HL		;Save the pointer in DE.
	RST	20H;NEXT_CHAR	;Is the next char
	CP	')'		;a ')'?
	JR	NZ,L0672;SA_V_OLD ;Give report C if it is not.
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L1BEE;CHECK_END	;Move on to the next statement
				;if checking syntax.
	EX	DE,HL		;Return the pointer to the HL reg pair before
	JP	L075A;SA_ALL	;jumping forward. (The pointer indicates the
				;start of an existing array's contents.)

;Now consider 'SCREEN$'.
L06A0:;SA_SCR$
	CP	0AAH		;Is the present code the token 'SCREEN$'?
	JR	NZ,L06C3;SA_CODE;Jump if not.
	LD	A,(L5C74);T_ADDR_lo ;However it is not possible to
	CP	3		;have 'MERGE name SCREEN$'.
	JP	Z,L1C8A;REPORT_C
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L1BEE;CHECK_END	;Move on to the next statement
				;if checking syntax.
	LD	(IX+0BH),0	;The display area and the attribute area
	LD	(IX+0CH),1BH	;occupy 1B00 locs and these locs
	LD	HL,L4000	;start at 4000; these details are
	LD	(IX+0DH),L	;passed to the header area
	LD	(IX+0EH),H	;in the work space.
	JR	L0710;SA_TYPE_3	;Jump forward.

;Now consider 'CODE'.
L06C3:;SA_CODE
	CP	0AFH		;Is the present code the token 'CODE'?
	JR	NZ,L0716;SA_LINE;Jump if not.
	LD	A,(L5C74);T_ADDR_lo ;However it is not possible to
	CP	3		;have 'MERGE name CODE'.
	JP	Z,L1C8A;REPORT_C
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L2048;PR_ST_END	;Jump forward if the statement
	JR	NZ,L06E1;SA_CODE_1 ;has not finished.
	LD	A,(L5C74);T_ADDR_lo ;However it is not possible to
	AND	A		;have 'SAVE name CODE' by
	JP	Z,L1C8A;REPORT_C;itself.
	CALL	L1CE6;USE_ZERO	;Put a zero on the calculator stack - for
	JR	L06F0;SA_CODE_2	;the 'start'. Jump forward.

;Look for a 'starting addr'.
L06E1:;SA_CODE_1
	CALL	L1C82;EXPT_1NUM	;Fetch the 1st number.
	RST	18H;GET_CHAR	;Is the present char a ','
	CP	','		;or not?
	JR	Z,L06F5;SA_CODE_3 ;Jump if it is - the number was
				;a 'starting addr'.
	LD	A,(L5C74);T_ADDR_lo ;However refuse 'SAVE name CODE'
	AND	A		;that does not have a
	JP	Z,L1C8A;REPORT_C;'start' and a 'length'.
L06F0:;SA_CODE_2
	CALL	L1CE6;USE_ZERO	;Put a zero on the calculator stack -
	JR	L06F9;SA_CODE_4	;for the 'length' and jump forward.

;Fetch the 'length' as it was specified.
L06F5:;SA_CODE_3
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L1C82;EXPT_1NUM	;Fetch the 'length'.

;The parameters are now stored in the header area of the work space.
L06F9:;SA_CODE_4
	CALL	L1BEE;CHECK_END	;But move on to the next statement now
				;if checking syntax.
	CALL	L1E99;FIND_INT2	;Compress the 'length' into
	LD	(IX+0BH),C	;the BC reg pair and
	LD	(IX+0CH),B	;store it.
	CALL	L1E99;FIND_INT2	;Compress the 'starting addr'
	LD	(IX+0DH),C	;into the BC reg pair and
	LD	(IX+0EH),B	;store it.
	LD	H,B		;Transfer the 'pointer' to the
	LD	L,C		;HL reg pair as usual.

;'SCREEN$' and 'CODE' are both of type 3.
L0710:;SY_TYPE_3
	LD	(IX+0),3	;Enter the 'type' number.
	JR	L075A;SA_ALL	;Rejoin the other pathways.

;Now consider 'LINE'; and 'no further parameters'.
L0716:;SA_LINE
	CP	0CAH		;Is the present code the token 'LINE'?
	JR	Z,L0723;SA_LINE_1 ;Jump if it is.
	CALL	L1BEE;CHECK_END	;Move on to the next statement if
				;checking syntax.
	LD	(IX+0EH),80H	;When there are no further parameters
	JR	L073A;SA_TYPE_0	;an 80 is entered; jump forward.

;Fetch the 'line number' that must follow 'LINE'.
L0723:;SA_LINE_1
	LD	A,(L5C74);T_ADDR_lo ;However only allow 'SAVE name
	AND	A		;LINE number'.
	JP	NZ,L1C8A;REPORT_C
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L1C82;EXPT_1NUM	;Pass the number to the calculator stack.
	CALL	L1BEE;CHECK_END	;Move on to the next statement if
				;checking syntax.
	CALL	L1E99;FIND_INT2	;Compress the 'line number'
	LD	(IX+0DH),C	;into the BC reg pair
	LD	(IX+0EH),B	;and store it.

;'LINE' and 'no further parameters' are both of type 0.
L073A:;SA_TYPE_0
	LD	(IX+0),0	;Enter the 'type' number.

;The parameters that describe the program, and its vars, are found and
;stored in the header area of the work space.
	LD	HL,(L5C59);E_LINE ;The pntr to the end of the vars area.
	LD	DE,(L5C53);PROG	;The pointer to the start of the BASIC
	SCF			;program. Now perform the subtraction
	SBC	HL,DE		;to find the length of the
	LD	(IX+0BH),L	;'program+vars'; store
	LD	(IX+0CH),H	;the result.
	LD	HL,(L5C4B);VARS	;Repeat the operation but this
	SBC	HL,DE		;time storing the length of the
	LD	(IX+0FH),L	;'program' only.
	LD	(IX+10H),H
	EX	DE,HL		;Transfer the 'pointer' to the HL
				;reg pair as usual.

;In all cases the header information has now been prepared.
;
;	The loc 'IX+00' holds the type number.
;	Locs 'IX+01 to IX+0A' holds the name (FF in 'IX+01' if null).
;	Locs 'IX+0B & IX+0C' hold the number of bytes that are to be
;	found in the 'data block'.
;	Locs 'IX+0D to IX+10' hold a variety of parameters whose exact
;	interpretation depends on the 'type'.
;
;The routine continues with the 1st task being to separate SAVE from LOAD,
;VERIFY and MERGE.
L075A:;SA_ALL
	LD	A,(L5C74);T_ADDR_lo ;Jump forward when handling
	AND	A		;a SAVE command.
	JP	Z,L0970;SA_CONTRL

;In the case of a LOAD, VERIFY or MERGE command the 1st 17 bytes of the
;'header area' in the work space hold the prepared information, as detailed
;above; and it is now time to fetch a 'header' from the tape.
	PUSH	HL		;Save the 'destination' pointer.
	LD	BC,11H		;Form in the IX reg pair the base
	ADD	IX,BC		;addr of the '2nd header area'.

;Now enter a loop; leaving it only when a 'header' has been LOADed.
L0767:;LD_LOOK_H
	PUSH	IX		;Make a copy of the base addr.
	LD	DE,11H		;LOAD 17 bytes.
	XOR	A		;Signal 'header'.
	SCF			;Signal 'LOAD'.
	CALL	L0556;LD_BYTES	;Now look for a header.
	POP	IX		;Retrieve the bas addr.
	JR	NC,L0767;LD_LOOK_H ;Go round the loop until successful.

;The new 'header' is now displayed on the screen but the routine will only
;proceed if the 'new' header matches the 'old' header.
	LD	A,0FEH		;Ensure that channel 'S'
	CALL	L1601;CHAN_OPEN	;is open.
	LD	(IY+52H),3;SCR_CT ;Set the scroll counter.
	LD	C,80H		;Signal 'names do not match'.
	LD	A,(IX+0)	;Compare the 'new' type
	CP	(IX+0EFH);-11	;against the 'old' type.
	JR	NZ,L078A;LD_TYPE;Jump if the 'types' do not match.
	LD	C,0F6H		;But if they do; signal '10
				;chars are to match'.
L078A:;LD_TYPE
	CP	4		;Clearly the 'header' is nonsence
	JR	NC,L0767;LD_LOOK_H ;if the 'type 4 or more'.

;The appropriate message - 'Program:', 'Number array:', 'Character array:'
;or 'Bytes:' is printed.
	LD	DE,L09C0	;The base addr of the message block.
	PUSH	BC		;Save the C reg whilst
	CALL	L0C0A;PO_MSG	;the appropriate message is
	POP	BC		;printed.

;The 'new name' is printed and as this is done the 'old' and the 'new'
;names are compared.
	PUSH	IX		;Make the DE reg pair
	POP	DE		;point to the 'new type' and
	LD	HL,0FFF0H	;the HL reg pair to the
	ADD	HL,DE		;'old name'.
	LD	B,0AH		;10 chars are to be considered.
	LD	A,(HL)		;Jump forward if the match is
	INC	A		;to be against an actual name.
	JR	NZ,L07A6;LD_NAME
	LD	A,C		;But if the 'old name' is 'null'
	ADD	A,B		;then signal '10 chars
	LD	C,A		;already match'.

;A loop is entered to print the chars of the 'new name'. The name will be
;accepted if the 'counter' reaches zero, at least.
L07A6:;LD_NAME
	INC	DE		;Consider each char of the
	LD	A,(DE)		;'new name' in turn.
	CP	(HL)		;Match it against the appropriate
	INC	HL		;char of the 'old name'.
	JR	NZ,L07AD;LD_CH_PR ;Do not count it if it does not
	INC	C		;match.
L07AD:;LD_CH_PR
	RST	10H;PRINT_A_1	;Print the 'new' char.
	DJNZ	L07A6;LD_NAME	;Loop for 10 chars.
	BIT	7,C		;Accept the name only if the
	JR	NZ,L0767;LD_LOOK_H ;counter has reached zero.
	LD	A,0DH		;Follow the 'new name' with
	RST	10H;PRINT_A_1	;a 'carriage return'.

;The correct header has been found and the time has come to consider the three
;commands LOAD, VERIFY & MERGE separately.
	POP	HL		;Fetch the pointer.
	LD	A,(IX+0)	;'SCREEN$ and CODE' are
	CP	3		;handled with VERIFY.
	JR	Z,L07CB;VR_CONTRL
	LD	A,(L5C74);T_ADDR_lo ;Jump forward if using a
	DEC	A		;LOAD command.
	JP	Z,L0808;LD_CONTRL
	CP	2		;Jump forward if using a MERGE command;
	JP	Z,L08B6;ME_CONTRL ;continue with a VERIFY command.

;	THE 'VERIFY' CONTROL ROUTINE
;The verification process involves the LOADing of a block of data, a byte at
;a time, but the bytes are not stored - only checked. This routine is also
;used to LOAD blocks of data that have been described with 'SCREEN$ & CODE'.
L07CB:;VR_CONTRL
	PUSH	HL		;Save the pointer.
	LD	L,(IX+0FAH);-6	;Fetch the 'number of bytes'
	LD	H,(IX+0FBH);-5	;as described in the 'old' header.
	LD	E,(IX+0BH)	;Fetch also the number from the
	LD	D,(IX+0CH)	;'new' header.
	LD	A,H		;Jump forward if the 'length' is
	OR	L		;unspecified.
	JR	Z,L07E9;VR_CONT_1 ;e.g. 'LOAD name CODE' only.
	SBC	HL,DE		;Give report R if attempting to LOAD
	JR	C,L0806;REPORT_R;a larger block than has been requested.
	JR	Z,L07E9;VR_CONT_1 ;Accept equal 'lengths'.
	LD	A,(IX+0)	;Also give report R if trying to verify blocks
	CP	3		;that are of unequal size. ('Old length'
	JR	NZ,L0806;REPORT_R ;greater than 'new length'.)

;The routine continues by considering the 'destination pointer'.
L07E9:;VR_CONT_1
	POP	HL		;Fetch the 'pointer', i.e. the 'start'.
	LD	A,H		;This 'pointer' will be used
	OR	L		;unless it is zero, in which
	JR	NZ,L07F4;VR_CONT_2 ;case the 'start' found in
	LD	L,(IX+0DH)	;the 'new' header will be used
	LD	H,(IX+0EH)	;instead.

;The VERIFY/LOAD flag is now considered and the actual LOAD made.
L07F4:;VR_CONT_2
	PUSH	HL		;Move the 'pointer' to the
	POP	IX		;IX reg pair.
	LD	A,(L5C74);T_ADDR_lo ;Jump forward unless using
	CP	2		;the VERIFY command; with
	SCF			;the carry flag signalling
	JR	NZ,L0800;VR_CONT_3 ;'LOAD'.
	AND	A		;Signal 'VERIFY'.
L0800:;VR_CONT_3
	LD	A,0FFH		;Signal 'accept data block only'
				;before LOADing the block.

;	THE 'LOAD A DATA BLOCK' SUBROUTINE
;This subroutine is common to all the 'LOADing' routines. In the case of
;LOAD & VERIFY it acts as a full return from the cassette handling routines
;but in the case of MERGE the data block has yet to be 'MERGEd'.
L0802:;LD_BLOCK
	CALL	L0556;LD_BYTES	;LOAD/VERIFY a data block.
	RET	C		;Return unless an error.

;Report R - Tape loading error
L0806:;REPORT_R
	RST	8		;Call the error handling
	DB	1AH		;routine.

;	THE 'LOAD' CONTROL ROUTINE
L0808:LD_CONTRL
	LD	E,(IX+0BH)	;Fetch the 'number of bytes'
	LD	D,(IX+0CH)	;as given in the 'new header'.
	PUSH	HL		;Save the 'destination pointer'.
	LD	A,H		;Jump forward unless trying
	OR	L		;to LOAD a previously
	JR	NZ,L0819;LD_CONT_1 ;undeclared array.
	INC	DE		;Add three bytes to the
	INC	DE		;length - for the name, the
	INC	DE		;low length & the high length
	EX	DE,HL		;of a new var.
	JR	L0825;LD_CONT_2	;Jump forward.

;Consider now if there is enough room in memory for the new data block.
L0819:;LD_CONT_1
	LD	L,(IX+0FAH);-6	;Fetch the size of the existing
	LD	H,(IX+0FBH);-5	;'program+vars or array'.
	EX	DE,HL
	SCF			;Jump forward if no extra
	SBC	HL,DE		;room will be required; taking into account
	JR	C,L082E;LD_DATA	;the reclaiming of the presently used memory.

;Make the actual test for room.
L0825:;LD_CONT_2
	LD	DE,5		;Allow an overhead of 5 bytes.
	ADD	HL,DE
	LD	B,H		;Move the result to the
	LD	C,L		;BC reg pair and make
	CALL	L1F05;TEST_ROOM	;the test.

;Now deal with the LOADing of arrays.
L082E:;LD_DATA
	POP	HL		;Fetch the 'pointer' anew.
	LD	A,(IX+0)	;Jump forward if LOADing
	AND	A		;a BASIC program.
	JR	Z,L0873;LD_PROG
	LD	A,H		;Jump forward if LOADing a
	OR	L		;new array.
	JR	Z,L084C;LD_DATA_1
	DEC	HL		;Fetch the 'length' of the
	LD	B,(HL)		;existing array by collecting
	DEC	HL		;the length bytes from the
	LD	C,(HL)		;var area.
	DEC	HL		;Point to its old name.
	INC	BC		;Add 3 bytes to the
	INC	BC		;length - one for the name
	INC	BC		;and two for the 'length'.
	LD	(L5C5F),IX;X_PTR;Save the IX reg pair
	CALL	L19E8;RECLAIM_2	;temporarily whilst the old
	LD	IX,(L5C5F);X_PTR;array is reclaimed.

;Space is now made available for the new array - at the end of the present
;vars area.
L084C:;LD_DATA_1
	LD	HL,(L5C59);E_LINE ;Find the pointer to the end-marker
	DEC	HL		;of the vars area - the '80-byte'.
	LD	C,(IX+0BH)	;Fetch the 'length' of the
	LD	B,(IX+0CH)	;new array.
	PUSH	BC		;Save this 'length'.
	INC	BC		;Add three bytes - one for
	INC	BC		;the name and two for the 'length'.
	INC	BC
	LD	A,(IX+0FDH);-3	;'IX+0E' of the old header gives the name
				;of the array.
	PUSH	AF		;The name is saved whilst the
	CALL	L1655;MAKE_ROOM	;appropriate amount of room is
	INC	HL		;made available. In effect 'BC'
	POP	AF		;spaces before the 'new 80 byte'.
	LD	(HL),A		;The name is entered.
	POP	DE		;The 'length' is fetched and
	INC	HL		;its two bytes are also
	LD	(HL),E		;entered.
	INC	HL
	LD	(HL),D
	INC	HL		;HL now points to the 1st loc that is
				;to be filled with data from the tape.
	PUSH	HL		;This addr is moved to the
	POP	IX		;IX reg pair; the carry
	SCF			;flag set; 'data block' is
	LD	A,0FFH		;signalled; and the block
	JP	L0802;LD_BLOCK	;LOADed.

;Now deal with the LOADing of a BASIC program and its vars.
L0873:;LD_PROG
	EX	DE,HL		;Save the 'destination pointer'.
	LD	HL,(L5C59);E_LINE ;Find the addr of the end-marker
	DEC	HL		;of the current vars area - the '80-byte'.
	LD	(L5C5F),IX;X_PTR;Save IX temporarily.
	LD	C,(IX+0BH)	;Fetch the 'length' of the
	LD	B,(IX+0CH)	;new data block.
	PUSH	BC		;Keep a copy of the 'length'
	CALL	L19E5;RECLAIM_1	;whilst the present program and
	POP	BC		;vars areas are reclaimed.
	PUSH	HL		;Save the pointer to the program area and
	PUSH	BC		;the length of the new data block.
	CALL	L1655;MAKE_ROOM	;Make sufficient room available for the new
				;program and its vars.
	LD	IX,(L5C5F);X_PTR;Restore the IX reg pair.
	INC	HL		;The system vars VARS
	LD	C,(IX+0FH)	;has also to be set for the
	LD	B,(IX+10H)	;new program.
	ADD	HL,BC
	LD	(L5C4B),HL;VARS
	LD	H,(IX+0EH)	;If a line number was
	LD	A,H		;specified then it too has to
	AND	0C0H		;be considered.
	JR	NZ,L08AD;LD_PROG_1 ;Jump if 'no number'; otherwise
	LD	L,(IX+0DH)	;set NEWPPC & NSPPC.
	LD	(L5C42),HL;NEWPPC
	LD	(IY+0AH),0;NSPPC

;The data block can now be LOADed.
L08AD:;LD_PROG_1
	POP	DE		;Fetch the 'length'.
	POP	IX		;Fetch the 'start'.
	SCF			;Signal 'LOAD'.
	LD	A,0FFH		;Signal 'data block' only.
	JP	L0802;LD_BLOCK	;Now LOAD it.

;	THE 'MERGE' CONTROL ROUTINE
L08B6:;ME_CONTRL
	LD	C,(IX+0BH)	;Fetch the 'length' of the
	LD	B,(IX+0CH)	;data block.
	PUSH	BC		;Save a copy of the 'length'.
	INC	BC		;Now made 'length+1' locs
	RST	30H;BC_SPACES	;available in the work space.
	LD	(HL),80H	;Place an end-marker in the extra loc.
	EX	DE,HL		;Move the 'start' pntr to the HL reg pair.
	POP	DE		;Fetch the original 'length'.
	PUSH	HL		;Save a copy of the 'start'.
	PUSH	HL		;Now set the IX reg pair
	POP	IX		;for the actual LOAD.
	SCF			;Signal 'LOAD'.
	LD	A,0FFH		;Signal 'data block only'.
	CALL	L0802;LD_BLOCK	;LOAD the data block.

;The lines of the new program are MERGEd with the lines of the old program.
	POP	HL		;Fetch the 'start' of the new program.
	LD	DE,(L5C53);PROG	;Jump when finished with all the lines.

;Enter a loop to deal with the lines of the new program.
L08D2:;ME_NEW_LP
	LD	A,(HL)		;Fetch a line number and
	AND	0C0H		;test it.
	JR	NZ,L08F0;ME_VAR_LP ;Jump when finished with all the lines.

;Now enter an inner loop to deal with the lines of the old program.
L08D7:;ME_OLD_LP
	LD	A,(DE)		;Fetch the high line number
	INC	DE		;byte and compare it.
	CP	(HL)		;Jump forward if it does not
	INC	HL		;match but in any case advance
	JR	NZ,L08DF;ME_OLD_L1 ;both pointers.
	LD	A,(DE)		;Repeat the comparison for the
	CP	(HL)		;low line number bytes.
L08DF:;ME_OLD_L1
	DEC	DE		;Now repeat the pointers.
	DEC	HL
	JR	NC,L08EB;ME_NEW_L2 ;Jump forward if the correct place has
				;been found for a line of the new program.
	PUSH	HL		;Otherwise find the addr of
	EX	DE,HL		;the start of the next old line.
	CALL	L19B8;NEXT_ONE
	POP	HL
	JR	L08D7;ME_OLD_LP	;Go round the loop for each of the 'old lines'.
L08EB:;ME_NEW_L2
	CALL	L092C;ME_ENTER	;Enter the 'new line' and go
	JR	L08D2;ME_NEW_LP	;round the outer loop again.

;In a similar manner the vars of the new program are MERGEd with the
;vars of the old program.
;  A loop is entered to deal with each of the new vars in turn.
L08F0:;ME_VAR_LP
	LD	A,(HL)		;Fetch each var name in
	LD	C,A		;turn and test it.
	CP	80H		;Return when all the vars
	RET	Z		;have been considered.
	PUSH	HL		;Save the current new pointer.
	LD	HL,(L5C4B);VARS	;Fetch VARS (for the old program).

;Now enter an inner loop to search the existing vars area.
L08F9:;ME_OLD_VP
	LD	A,(HL)		;Fetch each var name and
	CP	80H		;test it.
	JR	Z,L0923;ME_VAR_L2 ;Jump forward once the end-marker is
				;found. (Make an 'addition'.)
	CP	C		;Compare the names (1st bytes).
	JR	Z,L0909;ME_OLD_V2 ;Jump forward to consider it further;
				;returning here if it proves not
				;to match fully.
L0901:;ME_OLD_V1
	PUSH	BC		;Save the new var's name
	CALL	L19B8;NEXT_ONE	;whilst the next 'old var'
	POP	BC		;is located.
	EX	DE,HL		;Restore the pointer to the
	JR	L08F9;ME_OLD_VP	;DE reg pair and go round the loop again.

;The old and new vars match with respect to their 1st bytes but
;vars with long names will need to be matched fully.
L0909:;ME_OLD_V2
	AND	0E0H		;Consider bits 7, 6 & 5 only.
	CP	0A0H		;Accept all the var types
	JR	NZ,L0921;ME_VAR_L1 ;except 'long named vars'.
	POP	DE		;Make DE point to the 1st
	PUSH	DE		;char of the 'new name'.
	PUSH	HL		;Save the pointer to the 'old name'.

;Enter a loop to compare the letters of the long names.
L0912:;ME_OLD_V3
	INC	HL		;Update both the 'old' and
	INC	DE		;the 'new' pointers.
	LD	A,(DE)		;Compare the two letters.
	CP	(HL)
	JR	NZ,L091E;ME_OLD_V4 ;Jump forward if the match fails.
	RLA			;Go round the loop until the
	JR	NC,L0912;ME_OLD_V3 ;'last char' is found.
	POP	HL		;Fetch the pointer to the start
				;of the 'old' name and
	JR	L0921;ME_VAR_L1	;jump forward - successful.
L091E:;ME_OLD_V4
	POP	HL		;Fetch the pointer and jump
	JR	L0901;ME_OLD_V1	;back - unsuccessful.

;Come here if the match was found.
L0921:;ME_VAR_L1
	LD	A,0FFH		;Signal 'replace' var.

;And here if not. (A holds 80 - var to be 'added'.)
L0923:;ME_VAR_L2
	POP	DE		;Fetch pointer to 'new' name.
	EX	DE,HL		;Switch over the regs.
	INC	A		;The zero flag is to be set if there
				;is to be a 'replacement'; reset
				;for an 'addition'.
	SCF			;Signal 'handling vars'.
	CALL	L092C;ME_ENTER	;Now make the entry.
	JR	L08F0;ME_VAR_LP	;Go round the loop to consider the
				;next new var.

;	THE 'MERGE A LINE OR A VARIABLE' SUBROUTINE
;This subroutine is entered with the following parameters:
;
;  Carry flag	reset	- MERGE a BASIC line.
;		set	- MERGE a var.
;  Zero		reset	- It will be an 'addition'.
;		set	- It is a 'replacement'.
;  HL reg pair		- Points to the start of the new entry.
;  DE reg pair		- Points to where it is to MERGE.
L092C:;ME_ENTER
	JR	NZ,L093E;ME_ENT_1 ;Jump if handling an 'addition'.
	EX	AF,AF'		;Save the flags.
	LD	(L5C5F),HL;X_PTR;Save the 'new' pointer whilst
	EX	DE,HL		;the 'old' line or var
	CALL	L19B8;NEXT_ONE	;reclaimed.
	CALL	L19E8;RECLAIM_2
	EX	DE,HL
	LD	HL,(L5C5F);X_PTR
	EX	AF,AF'		;Restore the flags.

;The new entry can now be made.
L093E:;ME_ENT_1
	EX	AF,AF'		;Save the flags.
	PUSH	DE		;Make a copy of the 'destination' pointer.
	CALL	L19B8;NEXT_ONE	;Find the length of the 'new' var/line.
	LD	(L5C5F),HL;X_PTR;Save the pointer to the 'new' var/line.
	LD	HL,(L5C53);PROG	;Fetch PROG - to avoid corruption.
	EX	(SP),HL		;Save PROG on the stack and fetch the
				;'new' pointer.
	PUSH	BC		;Save the length.
	EX	AF,AF'		;Retrieve the flags.
	JR	C,L0955;ME_ENT_2;Jump forward if adding a new var.
	DEC	HL		;A new line is added before the
				;'destination' loc.
	CALL	L1655;MAKE_ROOM	;Make the room for the new line.
	INC	HL
	JR	L0958;ME_ENT_3
L0955:;ME_ENT_2
	CALL	L1655;MAKE_ROOM	;Make the room for the new var.
L0958:;ME_ENT_3
	INC	HL		;Point to the 1st new loc.
	POP	BC		;Retrieve the length.
	POP	DE		;Retrieve PROG and store it
	LD	(L5C53),DE;PROG	;in its correct place.
	LD	DE,(L5C5F);X_PTR;Also fetch the 'new' pointer.
	PUSH	BC		;Again save the length and the
	PUSH	DE		;'new' pointer.
	EX	DE,HL		;Switch the pointers and copy the 'new'
	LDIR			;var/line into the room made for it.

;The 'new' var/line has now to be removed from the work space.
	POP	HL		;Fetch the 'new' pointer.
	POP	BC		;Fetch the length.
	PUSH	DE		;Save the 'old' pointer. (Points to the
				;loc after the 'added' var/line.)
	CALL	L19E8;RECLAIM_2	;Remove the var/line from the work space.
	POP	DE		;Return with the 'old' pointer in the
	RET			;DE reg pair.

;	THE 'SAVE' CONTROL ROUTINE
;The operation of SAVEing a program or a block of data is very straighforward.
L0970:;SA_CONTRL
	PUSH	HL		;Save the 'pointer'.
	LD	A,0FDH		;Ensure that channel 'K'
	CALL	L1601;CHAN_OPEN	;is open.
	XOR	A		;Signal '1st message'.
	LD	DE,L09A1	;Print the message - 'Start tape,
	CALL	L0C0A;PO_MSG	;then press any key.'.
	SET	5,(IY+2);TV_FLAG;Signal 'screen will require to be cleared'.
	CALL	L15D4;WAIT_KEY	;Wait for a key to be pressed.

;Upon receipt of a keystroke the 'header' is saved.
	PUSH	IX		;Save the base addr of the 'header'
				;on the machine stack.
	LD	DE,11H		;17 bytes are to be SAVEd.
	XOR	A		;Signal 'it is a header'.
	CALL	L04C2;SA_BYTES	;Send the 'header'; with a leading 'type'
				;byte and a trailing 'parity' byte.

;There follows a short delay before the program/data block is SAVEd.
	POP	IX		;Retrieve the pointer to the 'header'.
	LD	B,32H		;The delay if for 50 (for 32H)
L0991:;SA_1_SEC
	HALT			;interrupts, i.e. one second.
	DJNZ	L0991;SA_1_SEC
	LD	E,(IX+0BH)	;Fetch the length of the
	LD	D,(IX+0CH)	;data block that is to be SAVEd.
	LD	A,0FFH		;Signal 'data block'.
	POP	IX		;Fetch the 'start of block
	JP	L04C2;SA_BYTES	;pointer' and SAVE the block.

;	THE CASSETTE MESSAGES
;Each message is given with the last char inverted (+80 hex.). 
L09A1:	
	DB	80H
	DB	'Start tape, then press any key','.'+80H
	DB	0DH,'Program:',' '+80H
	DB	0DH,'Number array:',' '+80H
	DB	0DH,'Character array:',' '+80H
	DB	0DH,'Bytes:',' '+80H

