
;	THE 'SLICING' SUBROUTINE
;The present string can be sliced using this subroutine. The subroutine is
;entered with the params of the string being present on the top of the calc
;stack and in the regs A, B, C, D & E. Initially the SYNTAX/RUN flag is
;tested and the params of the string are fetched only if a line is being
;executed.
L2A52:;SLICING
	CALL	L2530;SYNTAX_Z	;Check the flag.
	CALL	NZ,L2BF1;STK_FETCH ;Take the params off the
				;stack in 'run-time'.

;The possibility of the 'slice' being '()' has to be considered.
	RST	20H;NEXT_CHAR	;Get the next char.
	CP	')'		;Is it a ')'?
	JR	Z,L2AAD;SL_STORE ;Jump forward if it is so.

;Before proceeding the regs are manipulated as follows:
	PUSH	DE		;The 'start' goes on the machine stack.
	XOR	A		;The A reg is cleared
	PUSH	AF		;and saved.
	PUSH	BC		;The 'length' is saved briefly.
	LD	DE,1		;Presume that the 'slice' is to begin with
				;the 1st char.
	RST	18H;GET_CHAR	;Get the 1st char.
	POP	HL		;Pass the 'length' to HL.

;The 1st param of the 'slice' is now evaluated.
	CP	0CCH		;Is the present char a 'TO'?
	JR	Z,L2A81;SL_SECOND ;The 1st param, by default, will be '1'
				;if the jump is taken.
	POP	AF		;At this stage A is zero.
	CALL	L2ACD;INT_EXP2	;BC is made to hold the 1st param. A will
				;hold FF if there has been an 'out of
				;range' error.
	PUSH	AF		;Save the value anyway.
	LD	D,B		;Transfer the 1st param
	LD	E,C		;to DE.
	PUSH	HL		;Save the 'length' briefly.
	RST	18H;GET_CHAR	;Get the present char.
	POP	HL		;Restore the 'length'.
	CP	0CCH		;Is the present char a 'TO'?
	JR	Z,L2A81;SL_SECOND ;Jump forward to consider the 2nd param
	CP	')'		;if it is so; otherwise show that there is
L2A7A:;SL_RPT_C
	JP	NZ,L1C8A;REPORT_C ;a closing bracket.

;At this point a 'slice' of a single char has been identified, e.g. A$(4).
	LD	H,D		;The last char of the 'slice'
	LD	L,E		;is also the 1st char.
	JR	L2A94;SL_DEFINE	;Jump forward.

;The 2nd param of a 'slice' is now evaluated.
L2A81:;SL_SECOND
	PUSH	HL		;Save the 'length' briefly.
	RST	20H;NEXT_CHAR	;Get the next char.
	POP	HL		;Restore the 'length'.
	CP	')'		;Is the present char a ')'?
	JR	Z,L2A94;SL_DEFINE ;Jump if there is not a 2nd param.
	POP	AF		;If the 1st param was in range A will
				;hold zero; otherwise 0FFh.
	CALL	L2ACD;INT_EXP2	;Make BC hold the 2nd param.
	PUSH	AF		;Save the 'error reg'.
	RST	18H;GET_CHAR	;Get the present char.
	LD	H,B		;Pass the result obtained from INT_EXP2
	LD	L,C		;to the HL reg pair.
	CP	')'		;Check that there is a closing
	JR	NZ,L2A7A;SL_RPT_C ;bracket now.

;The 'new' params are now defined.
L2A94:;SL_DEFINE
	POP	AF		;Fetch the 'error reg'.
	EX	(SP),HL		;The 2nd param goes on the stack and
				;the 'start' goes to HL.
	ADD	HL,DE		;The 1st param is added to the 'start'.
	DEC	HL		;Go back a loc to get it correct.
	EX	(SP),HL		;The 'new start' goes on the stack and
				;the 2nd param goes to HL.
	AND	A		;Subtract the 1st params from the 2nd
	SBC	HL,DE		;to find the length of the 'slice'.
	LD	BC,0		;Initialise the 'new length'.
	JR	C,L2AA8;SL_OVER	;A negative 'slice' is a 'null string'
				;rather than an error condition.
				;(See manual.)
	INC	HL		;Allow for the inclusive byte.
	AND	A		;Only now test the 'error reg'.
	JP	M,L2A20;REPORT_3 ;Jump if either param was out of range
				;for the string.
	LD	B,H		;Transfer the 'new length'
	LD	C,L		;to BC.
L2AA8:;SL_OVER
	POP	DE		;Get the 'new start'.
	RES	6,(IY+1);FLAGS	;Ensure that a string is still indicated.
L2AAD:;SL_STORE
	CALL	L2530;SYNTAX_Z	;Return at this point if checking syntax;
	RET	Z		;otherwise continue into the STK_STORE
				;subroutine.

;	THE 'STK_STORE' SUBROUTINE
;This subroutine passes the values held in the A, B, C, D & E regs to the
;calc stack. The stack thereby grows in size by 5 bytes with every call
;to this subroutine.
;  The subroutine is normally used to transfer the params of strings but
;it is also used by STACK_BC and LOG(2^A) to transfer 'small integers'
;to the stack.
;  Note that when storing the params of a string the 1st value stored
;(coming from the A reg) will be a zero if the string comes from an array
;of strings or is a 'slice' of a string. The value will be '1' for a
;complete simple string. This 'flag' is used in the LET command routine
;when the '1' signals that the old copy of the string is to be 'reclaimed'.
L2AB1:;STK_ST_0
	XOR	A		;Signal - a string from an array of strings
				;or a 'sliced' string.
L2AB2:;STK_STO_$
	RES	6,(IY+1);FLAGS	;Ensure the flag indicates a string
				;result.
L2AB6:;STK_STORE
	PUSH	BC		;Save B & C briefly.
	CALL	L33A9;TEST_5_SP	;Is there room for 5 bytes? Do not return
				;here unless there is room available.
	POP	BC		;Restore B & C.
	LD	HL,(L5C65);STKEND ;Fetch the addr of the 1st loc above
				;the present stack.
	LD	(HL),A		;Transfer the 1st byte.
	INC	HL		;Step on.
	LD	(HL),E		;Transfer the 2nd and
	INC	HL		;3rd bytes; for a string
	LD	(HL),D		;these will be the 'start'.
	INC	HL		;Step on.
	LD	(HL),C		;Transfer the 4th and
	INC	HL		;5th bytes; for a string
	LD	(HL),B		;these will be the 'length'.
	INC	HL		;Step on so as to point to the loc above
	LD	(L5C65),HL;STKEND ;the stack. Save this addr in STKEND
	RET			;and return.

;	THE 'INT_EXP' SUBROUTINE
;This subroutine returns the result of evaluating the 'next expression' as
;an integer value held in the BC reg pair. The subroutine also tests this
;result against a limit-value supplied in the HL reg pair. The carry flag
;becomes set if there is an 'out of range' error.
;  The A reg is used as an 'error reg' and holds 0 of there is no 'previous
;error' and 0FFh if there has been one.
L2ACC:;INT_EXP1
	XOR	A		;Clear the 'error reg'.
L2ACD:;INT_EXP2
	PUSH	DE		;Save both the DE & HL reg pairs
	PUSH	HL		;throughout.
	PUSH	AF		;Save the 'error reg' briefly.
	CALL	L1C82;EXPT_1NUM	;The 'next expression' is evaluated to
				;give a 'last value' on the calc stack.
	POP	AF		;Restore the 'error reg'.
	CALL	L2530;SYNTAX_Z	;Jump forward if checking
	JR	Z,L2AEB;I_RESTORE ;syntax.
	PUSH	AF		;Save the error reg again.
	CALL	L1E99;FIND_INT2	;The 'last value' is compressed into BC.
	POP	DE		;Error reg to D.
	LD	A,B		;A 'next expression' that
	OR	C		;gives zero is always in
	SCF			;error so jump forward if it
	JR	Z,L2AE8;I_CARRY	;is so.
	POP	HL		;Take a copy of the limit-value. This will
	PUSH	HL		;be a 'dimension-size' a 'DIM-limit' or a
				;'string length'.
	AND	A		;Now compare the result of evaluating the
	SBC	HL,BC		;expression against the limit.

;The state of the carry flag and the value held in the D reg are now
;manipulated so as to give the appropriate value for the 'error reg'.
L2AE8:;I_CARRY
	LD	A,D		;Fetch the 'old error value'.
	SBC	A,0		;Form the 'new error value';
				;0 if no error at anytime; 0FFh or less
				;if an 'out or range' error on this pass
				;or on previous ones.

;Restore the regs before returning.
L2AEB:;I_RESTORE
	POP	HL		;Restore HL & DE.
	POP	DE
	RET			;Return; 'error reg' is the A reg.

;	THE 'DE,(DE+1)' SUBROUTINE
;This subroutine performs the construction - LD DE,(DE+1) - and returns HL
;pointing to 'DE+2'.
L2AEE:;DE,(DE+1)
	EX	DE,HL		;Use HL for the construction.
	INC	HL		;Point to 'DE+1'.
	LD	E,(HL)		;In effect - LD E,(DE+1).
	INC	HL		;Point to 'DE+2'.
	LD	D,(HL)		;In effect - LD D,(DE+2).
	RET			;Finished.

;	THE 'GET_HL*DE' SUBROUTINE
;Unless syntax is being checked this subroutine calls 'HL=HL*DE' which
;performs the implied construction.
;  Overflow of the 16 bits available in the HL reg pair gives the report
;'out of memory'. This is not exactly the true situation but it implies that
;the memory is not large enough for the task envisaged by the programmer.
L2AF4:;GET_HL*DE
	CALL	L2530;SYNTAX_Z	;Return directly if syntax is
	RET	Z		;being checked.
	CALL	L30A9;HL=HL*DE	;Perform the multiplication.
	JP	C,L1F15;REPORT_4 ;Report 'Out of memory'.
	RET			;Finished.

;	THE 'LET' COMMAND ROUTINE
;This is the actual assignment routine for the LET, READ and INPUT commands.
;  When the destination var is a 'newly declared var' then DEST will point
;to the 1st letter of the var's name as it occurs in the BASIC line. Bit 1
;of FLAGX will be set.
;  However if the destination var 'exists already' then bit 1 of FLAGX will
;be reset and DEST will point for a numeric var to the loc before the five
;bytes of the 'old number'; and for a string var to the 1st loc of the 'old
;string'. The use of DEST in this manner applies to simple vars and to
;elements of arrays.
;  Bit 0 of FLAGX is set if the destination var is a 'complete' simple
;string var. (Signalling - delete the old copy.)
;  Initially the current value of DEST is collected and bit 1 of FLAGX
;tested.
L2AFF:;LET
	LD	HL,(L5C4D);DEST	;Fetch the present addr in DEST.
	BIT	1,(IY+37H);FLAGX ;Jump if handling a var
	JR	Z,L2B66;L_EXISTS ;that 'exists already'.

;A 'newly declared var' is being used. So 1st the length of its name is
;found.
	LD	BC,5		;Presume dealing with a numeric var 5 bytes.

;Enter a loop to deal with the chars of a long name. Any spaces or colour
;codes in the name are ignored.
L2B0B:;L_EACH_CH
	INC	BC		;Add '1' to the counter for
				;each char of name.
L2B0C:;L_NO_SP
	INC	HL		;Move along the var's name.
	LD	A,(HL)		;Fetch the 'present code'.
	CP	' '		;Jump back if it is a 'space';
	JR	Z,L2B0C;L_NO_SP	;thereby ignoring spaces.
	JR	NC,L2B1F;L_TEST_CH ;Jump forward if the code is 21h to 0FFh.
	CP	10H		;Accept, as a final code, those
	JR	C,L2B29;L_SPACES ;in the range 0 to 0Fh.
	CP	16H		;Also accept the range
	JR	NC,L2B29;L_SPACES ;16h to 1Fh.
	INC	HL		;Step past the control code after any of
	JR	L2B0C;L_NO_SP	;INK to OVER. Jump back as these control
				;codes are treated as spaces.

;Separate 'numeric' and 'string' names.
L2B1F:;L_TEST_CH
	CALL	L2C88;ALPHANUM	;Is the code alphanumeric?
	JR	C,L2B0B;L_EACH_CH ;If it is so then accept it as
				;a char of a 'long' name.
	CP	'$'		;Is the present code a '$'?
	JP	Z,L2BC0;L_NEW$	;Jump forward as handling a 'newly
				;declared' simple string.

;The 'newly declared numeric var' presently being handled will require 'BC'
;spaces in the vars area for its name and its value. The room is made
;available and the name of the var is copied over with the chars being
;'marked' as required.
L2B29:;L_SPACES
	LD	A,C		;Copy the 'length' to A.
	LD	HL,(L5C59);E_LINE ;Make HL point to the '80-byte' as the
	DEC	HL		;end of the vars area.
	CALL	L1655;MAKE_ROOM	;Now open up the vars area. Note: In effect
				;'BC' spaces are made before the displaced
				;'80-byte'.
	INC	HL		;Point to the 1st 'new' byte.
	INC	HL		;Make DE point to the 2nd
	EX	DE,HL		;'new' byte.
	PUSH	DE		;Save the pntr.
	LD	HL,(L5C4D);DEST	;Fetch the pntr to the start of the name.
	DEC	DE		;Make DE point to the 1st 'new' byte.
	SUB	6		;Make B hold the 'number of extra letters'
	LD	B,A		;that are found in a 'long name'.
	JR	Z,L2B4F;L_SINGLE ;Jump forward if dealing with a var
				;with a 'short name'.

;The 'extra' codes of a long name are passed-to the vars area.
L2B3E:;L_CHAR
	INC	HL		;Point to each 'extra' code.
	LD	A,(HL)		;Fetch the code.
	CP	21h		;Accept codes from 21h to 0FFh;
	JR	C,L2B3E;L_CHAR	;ignore codes 0 to 20h.
	OR	20h		;Set bit 5, as for lower case letters.
	INC	DE		;Transfer the codes in turn to the
	LD	(DE),A		;2nd 'new' byte onwards.
	DJNZ	L2B3E;L_CHAR	;Go round the loop for all the 'extra' codes.

;The last code of a 'long' name has to be ORed with 80h.
	OR	80H		;Mark the code as required
	LD	(DE),A		;and overwrite the last code.

;The 1st letter of the name of the var being handled is now considered.
	LD	A,0C0H		;Prepare the mark the letter
				;of a 'long' name.
L2B4F:;L_SINGLE
	LD	HL,(L5C4D);DEST ;Fetch the pntr to the letter.
	XOR	(HL)		;A holds 0 for a 'short' name and 0C0h
				;for a 'long' name.
	OR	20h		;Set bit 5, as for lower case letters.
	POP	HL		;Drop the pntr now.

;The subroutine L_FIRST is now called to enter the 'letter' into its
;appropriate loc.
	CALL	L2BEA;L_FIRST	;Enter the letter and return with HL
				;pointing to 'new 80-byte'.

;The 'last value' can now be transferred to the vars area. Note that at
;this point HL always points to the loc after the five locs allotted to
;the number.
;  A 'RST 28' instruction is used to call the CALCULATOR and the 'last
;value' is deleted. However this value is not overwritten.
L2B59:;L_NUMERIC
	PUSH	HL		;Save the 'destination' pntr.
	RST	28H;FP_CALC	;Use the calc.
	DB	02H;delete	;This moves STKEND back five bytes.
	DB	38H;end_calc
	POP	HL		;Restore the pntr.
	LD	BC,5		;Give the number a 'length' of five bytes.
	AND	A		;Make HL point to the 1st
	SBC	HL,BC		;of the five locs and
	JR	L2BA6;L_ENTER	;jump forward to make the actual transfer.

;Come here if considering a var that 'exists already'. 1st bit 6 of FLAGS
;is tested so as to separate numeric vars from string or array of string
;vars.
L2B66:;L_EXISTS
	BIT	6,(IY+1);FLAGS	;Jump forward if handling any
	JR	Z,L2B72;L_DELETE$ ;kind of string var.

;For numeric vars the 'new' number overwrites the 'old' number. So 1st HL
;has to be made to point to the loc after the five bytes of the existing
;entry. At present HL points to the loc before the five bytes.
	LD	DE,6		;The five bytes of a number + '1'.
	ADD	HL,DE		;HL now points 'after'.
	JR	L2B59;L_NUMERIC	;Jump back to make the actual transfer.

;The params of the string var are fetched and complete simple strings
;separated from 'sliced' strings and array strings.
L2B72:;L_DELETE$
	LD	HL,(L5C4D);DEST	;Fetch the 'start'. Note: This line is
				;redundant.
	LD	BC,(L5C72);STRLEN ;Fetch the 'length'.
	BIT	0,(IY+37H);FLAGX ;Jump if dealing with a complete simple
	JR	NZ,L2BAF;L_ADD$	;string; the old string will need to be
				;'deleted' in this case only.

;When dealing with a 'slice' of an existing simple string, a 'slice' of a
;string from an array of strings or a complete string from an array of
;strings there are two distinct stages involved. The 1st is to build up
;the 'new' string in the work space lengthening or shortening it as
;required. The 2nd stage is then to copy the 'new' string to its allotted
;room in the vars area.
;  However do nothing if the string has no 'length'.
	LD	A,B		;Return if the string is
	OR	C		;a null string.
	RET	Z

;Then make the required number of spaces available in the work space.
	PUSH	HL		;Save the 'start' (DEST).
	RST	30H;BC_SPACES	;Make the necessary amount of
				;room in the work space.
	PUSH	DE		;Save the pntr to the 1st loc.
	PUSH	BC		;Save the 'length' for use later on.
	LD	D,H		;Make DE point to the last loc.
	LD	E,L
	INC	HL		;Make HL point 'one-past' the new loc.
	LD	(HL),' '	;Enter a 'space' char.
	LDDR			;Copy this char into all the new locs.
				;Finish with HL pointing to the 1st new loc.

;The params of the string being handled are now fetched from the calc stack.
	PUSH	HL		;Save the pntr briefly.
	CALL	L2BF1;STK_FETCH	;Fetch the 'new' params.
	POP	HL		;Restore the pntr.

;Note: At this point the required amount of room has been made available in
;the work space for the 'var in assignment'. e.g. For the stmt
;LET A$(4 TO 8)="abcdefg" - five locs have been made.
;  The params fetched above as a 'last value' represent the string that is
;to be copied into the new locs with Procrustean lengthening or shortening
;as required.
;  The length of the 'new' string is compared to the length of the room made
;available for it.
	EX	(SP),HL		;'Length' of new area to HL. 'Pntr' to new
				;area to stack.
	AND	A		;Compare the two 'lengths'
	SBC	HL,BC		;and jump forward if the 'new'
	ADD	HL,BC		;string will fit into the room.
	JR	NC,L2B9B;L_LENGTH ;i.e. No shortening required.
	LD	B,H		;However modify the 'new'
	LD	C,L		;length if it is too long.
L2B9B:;L_LENGTH
	EX	(SP),HL		;'Length' of new area to stack.
				;'Pointer' to new area to HL.

;As long as the new string is not a 'null string' it is copied into the
;work space. Procrustean lengthening is achieved automatically if the 'new'
;string is shorter than the room available for it.
	EX	DE,HL		;'Start' of new string to HL.
				;'Pntr' to new area to DE.
	LD	A,B		;Jump forward is the
	OR	C		;'new' string is a 'null'
	JR	Z,L2BA3;L_IN_W/S ;string.
	LDIR			;Otherwise move the 'new' string
				;to the work space.

;The values that have been saved on the machine stack are restored.
L2BA3:;L_IN_W/S
	POP	BC		;'Length' of new area.
	POP	DE		;'Pntr' to new area.
	POP	HL		;The 'start' - the pntr to the var in
				;assignment which was originally in DEST.
				;L_ENTER is now used to pass the 'new'
				;string to the vars area.

;	THE 'L_ENTER' SUBROUTINE
;This short subroutine is used to pass either a numeric value, from the
;calc stack, or a string, from the work space, to its appropriate position
;in the vars area.
;  The subroutine is therefore used for all except 'newly declared' simple
;strings and 'complete & existing' simple strings.
L2BA6:;L_ENTER
	EX	DE,HL		;Change the pntrs over.
	LD	A,B		;Check once again that the
	OR	C		;length is not zero.
	RET	Z
	PUSH	DE		;Save the destination pntr.
	LDIR			;Mave the numeric value or the string.
	POP	HL		;Return with the HL reg pair pointing to
	RET			;the 1st byte of the numeric value or the
				;string.

;	THE LET SUBROUTINE CONTINUES HERE
;When handling a 'complete & existing' simple string the new string is
;entered as if it were a 'newly declared' simple string before the existing
;version is 'reclaimed'.
L2BAF:;L_ADD$
	DEC	HL		;Make HL point to the letter
	DEC	HL		;of the var's name.
	DEC	HL		;i.e. DEST - 3.
	LD	A,(HL)		;Pick up the letter.
	PUSH	HL		;Save the pntr to the 'existing version'.
	PUSH	BC		;Save the 'length' of the 'existing string'.
	CALL	L2BC6;L_STRING	;Use L_STRING to add the new string to the
	POP	BC		;vars area. Restore the 'length'.
	POP	HL		;Restore the pntr.
	INC	BC		;Allow one byte for the letter
	INC	BC		;and two bytes for the length.
	INC	BC		;Exit by jumping to RECLAIM_2 which will
	JP	L19E8;RECLAIM_2	;reclaim the whole of the existing version.

;'Newly declared' simple strings are handled as follows:
L2BC0:;L_NEW$
	LD	A,0DFH		;Prepare for the marking of the var's
	LD	HL,(L5C4D);DEST	;letter. Fetch the pntr to the letter.
	AND	(HL)		;Mark the letter as required. L_STRING is
				;now used to add the new string to the
				;vars area.

;	THE 'L_STRING' SUBROUTINE
;The params of the 'new' string are fetched, sufficient room is made
;available for it and the string is then transferred.
L2BC6:;L_STRING
	PUSH	AF		;Save the var's letter.
	CALL	L2BF1;STK_FETCH	;Fetch the 'start' and the 'length' of the
	EX	DE,HL		;'new' string. Move the 'start' to HL.
	ADD	HL,BC		;Make HL point 'one-past' the string.
	PUSH	BC		;Save the 'length'.
	DEC	HL		;Make HL point to the end of the string.
	LD	(L5C4D),HL;DEST	;Save the pntr briefly.
	INC	BC		;Allow one byte for the letter
	INC	BC		;and two bytes for the length.
	INC	BC
	LD	HL,(L5C59);E_LINE ;Make HL point to the '80-byte' at the
	DEC	HL		;end of the vars area.
	CALL	L1655;MAKE_ROOM	;Now open up the vars area. Note: In effect
				;'BC' spaces are made before the displaced
				;'80-byte'.
	LD	HL,(L5C4D);DEST ;Restore the pntr to the end of the 'new'
	POP	BC		;string. Make a copy of the length of
	PUSH	BC		;the 'new' string. Add one to the length in
	INC	BC		;case the 'new' string is a 'null' string.
	LDDR			;Now copy the 'new' string + one byte.
	EX	DE,HL		;Make HL point to the byte
	INC	HL		;that is to hold the high-length.
	POP	BC		;Fetch the 'length'.
	LD	(HL),B		;Enter the high-length.
	DEC	HL		;Back one.
	LD	(HL),C		;Enter the low-length.
	POP	AF		;Fetch the var's letter.

;	THE 'L_FIRST' SUBROUTINE
;This subroutine is entered with the letter of the var, suitably marked,
;in the A reg. The letter overwrites the 'old 80-byte' in the vars area.
;The subroutine returns with the HL reg pair pointing to the 'new 80-byte'.
L2BEA:;L_FIRST
	DEC	HL		;Make HL point to the 'old 80-byte'.
	LD	(HL),A		;It is overwritten with the letter of the
	LD	HL,(L5C59);E_LINE ;var. Make HL point to the 'new 80-byte'.
	DEC	HL		;Finished with all the
	RET			;'newly declared vars'.

;	THE 'STK_FETCH' SUBROUTINE
;This important subroutine collects the 'last value' from the calc stack.
;The five bytes can be either a flpnt number, in 'short' or 'long' form,
;or a set of params that define a string.
L2BF1:;STK_FETCH
	LD	HL,(L5C65);STKEND ;Get STKEND.
	DEC	HL		;Back one.
	LD	B,(HL)		;The 5th value.
	DEC	HL		;Back one.
	LD	C,(HL)		;The 4th value.
	DEC	HL		;Back one.
	LD	D,(HL)		;The 3rd value.
	DEC	HL		;Back one.
	LD	E,(HL)		;The 2nd value.
	DEC	HL		;Back one.
	LD	A,(HL)		;The 1st value.
	LD	(L5C65),HL;STKEND ;Reset STKEND to its new position.
	RET			;Finished.

;	THE 'DIM' COMMAND ROUTINE
;This routine established new arrays in the vars area. The routine starts
;by searching the existing vars area to determine whether there is an
;existing array with the same name. If such an array is found then it is
;'reclaimed' before the new array is established.
;  A new array will have all its elements set to zero, if it is a numeric
;array, or to 'spaces', if it is an array of strings.
L2C02:;DIM
	CALL	L28B2;LOOK_VARS	;Search the vars area.
L2C05:;D_RPORT_C
	JP	NZ,L1C8A;REPORT_C ;Give report C as there has been an error.
	CALL	L2530;SYNTAX_Z	;Jump forward if in
	JR	NZ,L2C15;D_RUN	;'run-time'.
	RES	6,C		;Test the syntax for string arrays
				;as if they were numeric.
	CALL	L2996;STK_VAR	;Check the syntax of the
				;parenthesised expression.
	CALL	L1BEE;CHECK_END	;Move on to consider the next stmt as the
				;syntax was satisfactory.

;An 'existing array' is reclaimed.
L2C15:;D_RUN
	JR	C,L2C1F;D_LETTER ;Jump forward if there is no 'existing
	PUSH	BC		;array'. Save the discriminator byte.
	CALL	L19B8;NEXT_ONE	;Find the start of the next var.
	CALL	L19E8;RECLAIM_2	;Reclaim the 'existing array'.
	POP	BC		;Restore the discriminator byte.

;The initial params of the new array are found.
L2C1F:;D_LETTER
	SET	7,C		;Set bit 7 in the discriminator byte.
	LD	B,0		;Make the dimension counter zero.
	PUSH	BC		;Save the counter and the discr byte.
	LD	HL,1		;The HL reg pair is to hold
	BIT	6,C		;the size of the elements
	JR	NZ,L2C2D;D_SIZE	;in the array, '1' for a string
	LD	L,5		;array / '5' for a numeric array.
L2C2D:;D_SIZE
	EX	DE,HL		;Element size to DE.

;The following loop is accessed for each dimension that is specified in
;the parenthesised expression of the DIM stmt. The total number of bytes
;required for the elements of the array is built up in the DE reg pair.
L2C2E:;D_NO_LOOP
	RST	20H;NEXT_CHAR	;Advance CH_ADD on each pass.
	LD	H,0FFH		;Set a 'limit-value'.
	CALL	L2ACC;INT_EXP1	;Evaluate a parameter.
	JP	C,L2A20;REPORT_3 ;Give an error if 'out of range'.
	POP	HL		;Fetch the dimension-counter and
				;the discriminator byte.
	PUSH	BC		;Save the param on each pass through the
	INC	H		;loop. Increase the dimension-counter
				;on each pass also.
	PUSH	HL		;Restack the dimension-counter and the
				;discriminator byte.
	LD	H,B		;The param is moved to
	LD	L,C		;the HL reg pair.
	CALL	L2AF4;GET_HL*DE	;The byte total is built up
	EX	DE,HL		;in HL and then transferred to DE.
	RST	18H;GET_CHAR	;Get the present char
	CP	','		;and go around the loop again
	JR	Z,L2C2E;D_NO_LOOP ;if there is another dimension.
;Note: At this point the DE reg pair indicates the number of bytes required
;for the elements of the new array and the size of each dimension is stacked
;on the machine stack.
;  Now check that there is indeed a closing bracket to the parenthesised
;expression.
	CP	')'		;Is it a ')'?
	JR	NZ,L2C05;D_RPORT_C ;Jump back if not so.
	RST	20H;NEXT_CHAR	;Advance CH_ADD past it.

;Allowance is now made for the dimension-sizes.
	POP	BC		;Fetch the dim-counter and the discr byte.
	LD	A,C		;Pass the discr byte to the A reg for later.
	LD	L,B		;Move the counter to L.
	LD	H,0		;Clear the H reg.
	INC	HL		;Increase the dim-counter by two and
	INC	HL		;double the result and form the
	ADD	HL,HL		;correct overall length for the var
	ADD	HL,DE		;by adding the element byte total.
	JP	C,L1F15;REPORT_4 ;Give the report 'Out of memory' if
	PUSH	DE		;required. Save the element byte total.
	PUSH	BC		;Save the dim-counter and the discr byte.
	PUSH	HL		;Save the overall length also.
	LD	B,H		;Move the overall length to BC.
	LD	C,L

;The required amount of room is made available for the new array at the
;end of the vars area.
	LD	HL,(L5C59);E_LINE ;Make the HL reg pair
	DEC	HL		;point to the '80-byte'.
	CALL	L1655;MAKE_ROOM	;The room is made available.
	INC	HL		;HL is made to point to the 1st new loc.

;The params are now entered.
	LD	(HL),A		;The letter, suitably marked, is entered
	POP	BC		;1st. The overall length is fetched
	DEC	BC		;and decreased by '3'.
	DEC	BC
	DEC	BC
	INC	HL		;Advance HL.
	LD	(HL),C		;Enter the low length.
	INC	HL		;Advance HL.
	LD	(HL),B		;Enter the high length.
	POP	BC		;Fetch the dim-counter.
	LD	A,B		;Move it to the A reg.
	INC	HL		;Advance HL.
	LD	(HL),A		;Enter the dim count.

;The elements of the new array are now 'cleared'.
	LD	H,D		;HL is made to point to the last loc
	LD	L,E		;of the array and DE to the loc
	DEC	DE		;before that one.
	LD	(HL),0		;Enter a zero into the last
	BIT	6,C		;loc but overwrite it
	JR	Z,L2C7C;DIM_CLEAR ;with a 'space' if dealing
	LD	(HL),' '	;with an array of strings.
L2C7C:;DIM_CLEAR
	POP	BC		;Fetch the element byte total.
	LDDR			;Clear the array + one extra loc.

;The 'dimension-sizes' are now entered.
L2C7F:;DIM_SIZES
	POP	BC		;Get a dimension-size.
	LD	(HL),B		;Enter the high byte.
	DEC	HL		;Back one.
	LD	(HL),C		;Enter the low byte.
	DEC	HL		;Back one.
	DEC	A		;Decrease the dim counter.
	JR	NZ,L2C7F;DIM_SIZES ;Repeat the operation until all the dims
	RET			;have been considered; then return.

