
;	THE 'LPRINT & PRINT' COMMAND ROUTINES
;The appropriate channel is opened as necessary and the items to be
;printed are considered in turn.
L1FC9:;LPRINT
	LD	A,3		;Prepare to open channel 'P'.
	JR	L1FCF;PRINT_1	;Jump forward.
L1FCD:;PRINT
	LD	A,2		;Prepare to open channel 'S'.
L1FCF:;PRINT_1
	CALL	L2530;SYNTAX_Z	;Unless syntax is being
	CALL	NZ,L1601;CHAN_OPEN ;checked open a channel.
	CALL	L0D4D;TEMPS	;Set the temporary colour system vars.
	CALL	L1FDF;PRINT_2	;Call the print controlling subroutine.
	CALL	L1BEE;CHECK_END	;Move on to consider the next stmt; via
	RET			;CHECK_END if checking syntax.

;The print controlling subroutine is called by the PRINT, LPRINT and INPUT
;command routines.
L1FDF:;PRINT_2
	RST	18H;GET_CHAR	;Get the 1st char.
	CALL	L2045;PR_END_Z	;Jump forward if already at the
	JR	Z,L1FF2;PRINT_4	;end of the item list.

;Now enter a loop to deal with the 'position controllers' and the
;print items.
L1FE5:;PRINT_3
	CALL	L204E;PR_POSN_1	;Deal with any consecutive
	JR	Z,L1FE5;PRINT_3	;position controllers.
	CALL	L1FFC;PR_ITEM_1	;Deal with a single print item.
	CALL	L204E;PR_POSN_1	;Check for further position controllers and
	JR	Z,L1FE5;PRINT_3	;print items until there are none left.
L1FF2:;PRINT_4
	CP	')'		;Return now if the present char is a ')';
	RET	Z		;otherwise consider performinga 'carriage
				;return'.

;	THE 'PRINT A CARRIAGE RETURN' SUBROUTINE
L1FF5:;PRINT_CR
	CALL	L1FC3;UNSTACK_Z	;Return if checking syntax.
	LD	A,0DH		;Print a carriage return
	RST	10H;PRINT_A_1	;char and then return.
	RET

;	THE 'PRINT ITEMS' SUBROUTINE
;This subroutine is called from the PRINT, LPRINT and INPUT command routines.
;  The various types of print item are identified and printed.
L1FFC:;PR_ITEM_1
	RST	18H;GET_CHAR	;The 1st char is fetched.
	CP	0ACH		;Jump forward unless it is
	JR	NZ,L200E;PR_ITEM_2 ;an 'AT'.

;Now deal with an 'AT'.
	CALL	L1C79;NEXT_2NUM	;The two params are transferred to the
				;calc stack.
	CALL	L1FC3;UNSTACK_Z	;Return now if checking syntax.
	CALL	L2307;STK_TO_BC	;The params are compressed into the
				;BC reg pair.
	LD	A,16H		;The A reg is loaded with the AT control
	JR	L201E;PR_AT_TAB	;char before the jump is taken.

;Next look for a 'TAB'.
L200E:;PR_ITEM_2
	CP	0ADH		;Jump forward unless it is
	JR	NZ,L2024;PR_ITEM_3 ;a 'TAB'.

;Now deal with a 'TAB'.
	RST	20H;NEXT_CHAR	;Get the next char.
	CALL	L1C82;EXPT_1NUM	;Transfer one param to the calc stack.
	CALL	L1FC3;UNSTACK_Z	;Return now if checking syntax.
	CALL	L1E99;FIND_INT2	;The value is compressed into the
				;BC reg pair. The A reg is loaded
	LD	A,17H		;with the TAB control char.

;The 'AT' and the 'TAB' print items are printed by making three calls to
;PRINT_OUT.
L201E:;PR_AT_TAB
	RST	10H;PRINT_A_1	;Print the control char.
	LD	A,C		;Follow it with the 1st
	RST	10H;PRINT_A_1	;value.
	LD	A,B		;Finally print the 2nd
	RST	10H;PRINT_A_1	;value; then return.
	RET

;Next consider embedded colour items.
L2024:;PR_ITEM_3
	CALL	L21F2;CO_TEMP_3	;Return with carry reset if a
				;colour items was found.
	RET	NC		;Continue if none were found.
	CALL	L2070;STR_ALTER	;Next consider if the stream is
				;to be changed.
	RET	NC		;Continue unless it was altered.

;The print item must now be an expression, either numeric or string.
	CALL	L24FB;SCANNING	;Evaluate the expression but
	CALL	L1FC3;UNSTACK_Z	;return now if checking syntax.
	BIT	6,(IY+1);FLAGS	;Test for the nature of the expression.
	CALL	Z,L2BF1;STK_FETCH ;If it is a string then fetch the
				;necessary params; but if it is
	JP	NZ,L2DE3;PRINT_FP ;numeric then exit via PRINT_FP.

;A loop is now set up to deal with each char in turn of the string.
L203C:;PR_STRING
	LD	A,B		;Return now if there are
	OR	C		;no chars remaining
	DEC	BC		;in the string; otherwise
	RET	Z		;decrease the counter.
	LD	A,(DE)		;Fetch the code and increment
	INC	DE		;the pntr.
	RST	10H;PRINT_A_1	;The code is printed and a jump taken
	JR	L203C;PR_STRING	;to consider any further chars.

;	THE 'END OF PRINTING' SUBROUTINE
;The zero flag will be set if no further printing is to be done.
L2045:;PR_END_Z
	CP	')'		;Return now if the char
	RET	Z		;is a ')'.
L2048:;PR_ST_END
	CP	0DH		;Return now if the char is
	RET	Z		;a 'carriage return'.
	CP	':'		;Make a final test against ':'
	RET			;before returning.

;	THE 'PRINT POSITION' SUBROUTINE
;The various position controlling chars are considered by this subroutine.
L204E:;PR_POSN_1
	RST	18H;GET_CHAR	;Get the present char.
	CP	';'		;Jump forward if it is
	JR	Z,L2067;PR_POSN_3 ;a ';'.
	CP	','		;Also jump forward with a
	JR	NZ,L2061;PR_POSN_2 ;char other than a ',';
	CALL	L2530;SYNTAX_Z	;but do not actually print the
	JR	Z,L2067;PR_POSN_3 ;char if checking syntax.
	LD	A,6		;Load the A reg with
	RST	10H;PRINT_A_1	;the 'comma' control code and
	JR	L2067;PR_POSN_3	;print it; then jump forward.
L2061:;PR_POSN_2
	CP	''''		;Is it a ''''? Return now if not any
	RET	NZ		;of the position controllers.
	CALL	L1FF5;PR_CR	;Print 'carriage return' unless
				;checking syntax.
L2067:;PR_POSN_3
	RST	20H;NEXT_CHAR	;Fetch the next char.
	CALL	L2045;PR_END_Z	;If not at the end of a print
	JR	NZ,L206E;PR_POSN_4 ;stmt then jump forward;
	POP	BC		;otherwise return to the
L206E:	
	CP	A		;calling routine. The zero flag will be
	RET			;reset if the end of the print stmt
				;zas not been reached.

;	THE 'ALTER STREAM' SUBROUTINE
L2070:;STR_ALTER
	CP	'#'		;Unless the present char
	SCF			;is a '#' return with the
	RET	NZ		;carry flag set.
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L1C82;EXPT_1NUM	;Pas the param to the calc stack.
	AND	A		;Clear the carry flag.
	CALL	L1FC3;UNSTACK_Z	;Return now if checking syntax.
	CALL	L1E94;FIND_INT1	;The value is passed to the A reg.
	CP	10H		;Give report Q if the value is
	JP	NC,L160E;REPORT_Q ;over 10h.
	CALL	L1601;CHAN_OPEN	;Use the channel for the stream in question.
	AND	A		;Clear the carry flag
	RET			;and return.

;	THE 'INPUT' COMMAND ROUTINE
;This routine allows for values entered from the keyboard to be assigned to
;vars. It is also possible to have print items embedded in the INPUT stmt
;and these items are printed in the lower part of the display.
L2089:;INPUT
	CALL	L2530;SYNTAX_Z	;Jump forward if syntax is
	JR	Z,L2096;INPUT_1	;being checked.
	LD	A,1		;Open channel 'K'.
	CALL	L1601;CHAN_OPEN
	CALL	L0D6E;CLS_LOWER	;The lower part of the display is cleared.
L2096:;INPUT_1
	LD	(IY+2),1;DF_SZ	;Set the lower part to be only one line
				;in size.
	CALL	L20C1;IN_ITEM_1	;Call the subroutine to deal with
				;the INPUT items.
	CALL	L1BEE;CHECK_END	;Move on to the next stmt if checking syntax.
	LD	BC,(L5C88);S_POSN ;Fetch the current print position.
	LD	A,(L5C6B);DF_SZ	;Jump forward if the current
	CP	B		;position is above the lower
	JR	C,L20AD;INPUT_2	;screen.
	LD	C,21h		;Otherwise set the print position
	LD	B,A		;to the top of the lower screen.
L20AD:;INPUT_2
	LD	(L5C88),BC;S_POSN ;Reset S_POSN.
	LD	A,19H		;Now set the scroll counter.
	SUB	B
	LD	(L5C8C),A;SCR_CT
	RES	0,(IY+2);TV_FLAG ;Signal 'main screen'.
	CALL	L0DD9;CL_SET	;Set the system vars
	JP	L0D6E;CLS_LOWER	;and exit via CLS_LOWER.

;The INPUT items and embedded PRINT items are dealt with in turn by the
;following loop.
L20C1:;IN_ITEM_1
	CALL	L204E;PR_POSN_1	;Consider 1st any position
	JR	Z,L20C1;IN_ITEM_1 ;control chars.
	CP	'('		;Jump forward if the present
	JR	NZ,L20D8;IN_ITEM_2 ;char is not a '('.
	RST	20H;NEXT_CHAR	;Fetch the next char.
	CALL	L1FDF;PRINT_2	;Now call the PRINT command routine to
				;handle the items inside the brackets.
	RST	18H;GET_CHAR	;Fetch the present char.
	CP	')'		;Give report C unless the
	JP	NZ,L1C8A;REPORT_C ;char is a ')'.
	RST	20H;NEXT_CHAR	;Fetch the next char and jump forward to
	JP	L21B2;IN_NEXT_2	;see if there are any further INPUT items.

;Now consider whether INPUT LINE is being used.
L20D8:;IN_ITEM_2
	CP	0CAH		;Jump forward if it is not
	JR	NZ,L20ED;IN_ITEM_3 ;'LINE'.
	RST	20H;NEXT_CHAR	;Advance CH_ADD.
	CALL	L1C1F;CLASS_01	;Determine the destination addr for
				;the var.
	SET	7,(IY+37H);FLAGX ;Signal 'using INPUT LINE'.
	BIT	6,(IY+1);FLAGS	;Give report C unless using
	JP	NZ,L1C8A;REPORT_C ;a string var.
	JR	L20FA;IN_PROMPT	;Jump forward to issue the prompt message.

;Proceed to handle simple INPUT vars.
L20ED:;IN_ITEM_3
	CALL	L2C8D;ALPHA	;Jump to consider going round the loop again
	JP	NC,L21AF;IN_NEXT_1 ;if the present char is not a letter.
	CALL	L1C1F;CLASS_01	;Determine the destination addr for the var.
	RES	7,(IY+37H);FLAGX ;Signal 'not INPUT LINE'.

;The prompt message is now built up in the work space.
L20FA:;IN_PROMPT
	CALL	L2530;SYNTAX_Z	;Jump forward if only checking
	JP	Z,L21B2;IN_NEXT_2 ;syntax.
	CALL	L16BF;SET_WORK	;The work space is set to null.
	LD	HL,L5C71	;This is FLAGX.
	RES	6,(HL)		;Signal 'string result'.
	SET	5,(HL)		;Signal 'INPUT mode'.
	LD	BC,1		;Allow the prompt message only a single loc.
	BIT	7,(HL)		;Jump forward if using 'LINE'.
	JR	NZ,L211C;IN_PR_2
	LD	A,(L5C3B);FLAGS	;Jump forward if awaiting
	AND	40h		;a numeric entry.
	JR	NZ,L211A;IN_PR_1
	LD	C,3		;A string entry will need three locs.
L211A:;IN_PR_1
	OR	(HL)		;Bit 6 of FLAGX will become
	LD	(HL),A		;set for a numeric entry.
L211C:;IN_PR_2
	RST	30H;BC_SPACES	;The required number of locs is
				;made available.
	LD	(HL),0DH	;A 'carriage return' goes into the last loc.
	LD	A,C		;Test bit 6 of the C reg
	RRCA			;and jump forward if only
	RRCA			;one loc was required.
	JR	NC,L2129;IN_PR_3
	LD	A,'"'		;A 'double quotes' char
	LD	(DE),A		;goes into the 1st and
	DEC	HL		;2nd locs.
	LD	(HL),A
L2129:;IN_PR_3
	LD	(L5C5B),HL;K_CUR ;The position of the cursor can now be saved.

;In the case of INPUT LINE the EDITOR can be called without further
;preparation but for other types of INPUT the error stack has to be changed
;so as to trap errors.
	BIT	7,(IY+37H);FLAGX ;Jump forward with 'INPUT LINE'.
	JR	NZ,L215E;IN_VAR_3
	LD	HL,(L5C5D);CH_ADD ;Save the current values of
	PUSH	HL		;CH_ADD & ERR_SP on the
	LD	HL,(L5C3D);ERR_SP ;machine stack.
	PUSH	HL
L213A:;IN_VAR_1
	LD	HL,L213A	;This will be the 'return point'
	PUSH	HL		;in case of errors.
	BIT	4,(IY+30H);FLAGS2 ;Only change the error stack pntr
	JR	Z,L2148;IN_VAR_2 ;if using channel 'K'.
	LD	(L5C3D),SP;ERR_SP
L2148:;IN_VAR_2
	LD	HL,(L5C61);WORKSP ;Set HL to the start of the INPUT line
	CALL	L11A7;REMOVE_FP	;and remove any flpnt forms. (There will
				;not be any except perhaps after an error.)
	LD	(IY+00H),0FFH;ERR_NR ;Signal 'no error yet'.
	CALL	L0F2C;EDITOR	;Now get the INPUT and with the
	RES	7,(IY+01H);FLAGS ;syntax/run flag indicating syntax,
	CALL	L21B9;IN_ASSIGN	;check the INPUT for errors; jump if in
	JR	L2161;IN_VAR_4	;order; return to IN_VAR_1 if not.
L215E:;IN_VAR_3
	CALL	L0F2C;EDITOR	;Get a 'LINE'.

;All the system vars have to be reset before the actual assignment of a
;value can be made.
L2161:;IN_VAR_4
	LD	(IY+22H),0;K_CUR_hi ;The cursor addr is reset.
	CALL	L21D6;IN_CHAN_K	;The jump is taken if using
	JR	NZ,L2174;IN_VAR_5 ;other than channel 'K'.
	CALL	L111D;ED_COPY	;The input-line is copied to
	LD	BC,(L5C82);ECHO_E ;the display and the position in ECHO_E
	CALL	L0DD9;CL_SET	;made the current position in the
				;lower screen.
L2174:;IN_VARS_5
	LD	HL,L5C71	;This is FLAGX.
	RES	5,(HL)		;Signal 'edit mode'.
	BIT	7,(HL)		;Jump forward if handling an
	RES	7,(HL)		;INPUT LINE.
	JR	NZ,L219B;IN_VAR_6
	POP	HL		;Drop the addr IN_VAR_1.
	POP	HL		;Reset the ERR_SP to its
	LD	(L5C3D),HL;ERR_SP ;original addr.
	POP	HL		;Save the original CH_ADD
	LD	(L5C5F),HL;X_PTR ;addr in X_PTR.
	SET	7,(IY+01H);FLAGS ;Now with the syntax/run flag indicating
	CALL	L21B9;IN_ASSIGN	;'run' make the assignment.
	LD	HL,(L5C5F);X_PTR ;Restore the original addr
	LD	(IY+26H),0;X_PTR_hi ;to CH_ADD and clear X_PTR.
	LD	(L5C5D),HL;CH_ADD
	JR	L21B2;IN_NEXT_2	;Jump forward to see if there are
				;further INPUT items.
L219B:;IN_VARS_6
	LD	HL,(L5C63);STKBOT ;The length of the 'LINE' in
	LD	DE,(L5C61);WORKSP ;the work space is found.
	SCF
	SBC	HL,DE
	LD	B,H		;DE points to the start and
	LD	C,L		;BC holds the length.
	CALL	L2AB2;STK_STO_$	;These params are stacked
	CALL	L2AFF;LET	;and the actual assignment made.
	JR	L21B2;IN_NEXT_2	;Also jump forward to consider further items.

;Further items in the INPUT stmt are considered.
L21AF:;IN_NEXT_1
	CALL	L1FFC;PR_ITEM_1	;Handle any print items.
L21B2:;IN_NEXT_2
	CALL	L204E;PR_POSN_1	;Handle any position controllers.
	JP	Z,L20C1;IN_ITEM_1 ;Go around the loop again if there are
	RET			;further items; otherwise return.

;	THE 'IN_ASSIGNMENT' SUBROUTINE
;This subroutine is called twice for each INPUT value. Once with the
;syntax/run flag reset (syntax) and once with it set (run).
L21B9:;IN_ASSIGN
	LD	HL,(L5C61);WORKSP ;Set CH_ADD to point to the
	LD	(L5C5D),HL;CH_ADD ;1st loc of the work space and
	RST	18H;GET_CHAR	;fetch the char.
	CP	0E2H		;Is it a 'STOP'?
	JR	Z,L21D0;IN_STOP	;Jump if it is.
	LD	A,(L5C71);FLAGX	;Otherwise make the assignment
	CALL	L1C59;VAL_FET_2	;of the 'value' to the var.
	RST	18H;GET_CHAR	;Get the present char
	CP	0DH		;and check it is a 'carriage
	RET	Z		;return'. Return if it is.

;Report C - Nonsence in BASIC
L21CE:;REPORT_C
	RST	8;ERROR_1	;Call the error handling
	DB	0BH		;routine.

;Come here if the INPUT line starts with 'STOP'.
L21D0:;IN_STOP
	CALL	L2530;SYNTAX_Z	;But do not give the error
	RET	Z		;report on the syntax pass.

;Report H - STOP in INPUT
L21D4:;REPORT_H
	RST	8;ERROR_1	;Call the error handling
	DB	10H		;routine.

;	THE 'IN_CHAN_K' SUBROUTINE
;This subroutine returns with the zero flag reset only if channel 'K' is
;being used.
L21D6:;IN_CHAN_K
	LD	HL,(L5C51);CURCHL ;The base addr of the
	INC	HL		;channel information for the
	INC	HL		;current channel is fetched
	INC	HL		;and the channel code compared
	INC	HL		;to the char 'K'.
	LD	A,(HL)
	CP	'K'
	RET			;Return afterwards.

;	THE 'COLOUR ITEM' ROUTINES
;This set of routines can be readily divided into two parts:
;   i. The embedded colour item' handler.
;  ii. The 'colour system var' handler.

;   i. Embedded colour items are handled by calling the PRINT_OUT subroutine
;as required.
;  A loop is entered to handle each item in turn. The entry point is at
;CO_TEMP_2.
L21E1:;CO_TEMP_1
	RST	20H;NEXT_CHAR	;Consider the next char in the BASIC stmt.
L21E2:;CO_TEMP_2
	CALL	L21F2;CO_TEMP_3	;Jump forward to see if the present code
				;represents an embedded 'temporary' colour
	RET	C		;item. Return carry set if not a colour item.
	RST	18H;GET_CHAR	;Fetch the present char.
	CP	','		;Jump back if it is either a
	JR	Z,L21E1;CO_TEMP_1 ;',' or a ';'; otherwise
	CP	';'		;there has been an error.
	JR	Z,L21E1;CO_TEMP_1
	JP	L1C8A;REPORT_C	;Exit via 'report C'.
L21F2:;CO_TEMP_3
	CP	0D9H		;Return with the carry flag set if the
	RET	C		;code is not in the range 0D9h to 0DEh
	CP	0DFH		;(INK to OVER).
	CCF
	RET	C
	PUSH	AF		;The colour item code is
	RST	20h;NEXT_CHAR	;preserved whilst CH_ADD is advanced to
	POP	AF		;addr the param that follows it.

;The colour item code and the parameter are now 'printed' by calling
;PRINT_OUT on two occasions.
L21FC:;CO_TEMP_4
	SUB	0C9H		;The token range (0D9h to 0DEh) is reduced
				;to the control char range (10h to 15h).
	PUSH	AF		;The control char code is
	CALL	L1C82;EXPT_1NUM	;preserved whilst the parameter
	POP	AF		;is moved to the calc stack.
	AND	A		;A return is made at this point
	CALL	L1FC3;UNSTACK_Z	;if syntax is being checked.
	PUSH	AF		;The control char code is
	CALL	L1E94;FIND_INT1	;preserved whilst the parameter
	LD	D,A		;is moved to the D reg.
	POP	AF
	RST	10H;PRINT_A_1	;The control char is sent out.
	LD	A,D		;Then the parameter is fetched
	RST	10H;PRINT_A_1	;and sent out before
	RET			;returning.

;  ii. The colour system vars - ATTR_T, MASK_T & P_FLAG - are altered as
;required. This subroutine is called by PRINT_OUT. On entry the control
;char code is in the A reg and the parameter is in the D reg.
;  Note that all changes are to the 'temporary' system vars.
L2211:;CO_TEMP_5
	SUB	11H		;Reduce the range and jump
	ADC	A,0		;forward with INK & PAPER.
	JR	Z,L2234;CO_TEMP_7
	SUB	2		;Reduce the range once again
	ADC	A,0		;and jump forward with FLASH & BRIGHT.
	JR	Z,L2273;CO_TEMP_C

;The colour control code will now be 1 for INVERSE and 2 for OVER and the
;system var P_FLAG is altered accordingly.
	CP	1		;Prepare to jump with OVER.
	LD	A,D		;Fetch the param.
	LD	B,1		;Prepare the mask for OVER.
	JR	NZ,L2228;CO_TEMP_6 ;Now jump.
	RLCA			;Bit 2 of the A reg is to be reset for
	RLCA			;INVERSE 0 and set for INVERSE 1;
	LD	B,4		;the mask is to have bit 2 set.
L2228:;CO_TEMP_6
	LD	C,A		;Save the A reg whilst the range is tested.
	LD	A,D		;The correct range for
	CP	2		;INVERSE and OVER is only
	JR	NC,L2244;REPORT_K ;'0-1'.
	LD	A,C		;Fetch the A reg.
	LD	HL,L5C91	;It is P_FLAG that is to be changed.
	JR	L226C;CO_CHANGE	;Exit via CO_CHANGE and alter P_FLAG using
				;'B' as a mask. i.e. Bit 0 for OVER & bit 2
				;for INVERSE.

;PAPER & INK are dealt with by the following routine. On entry the carry flag
;is set for INK.
L2234:;CO_TEMP_7
	LD	A,D		;Fetch the param.
	LD	B,7		;Prepare the mask for INK.
	JR	C,L223E;CO_TEMP_8 ;Jump forward with INK.
	RLCA			;Multiply the param for
	RLCA			;PAPER by eight.
	RLCA
	LD	B,38h		;Prepare the mask for PAPER.
L223E:;CO_TEMP_8
	LD	C,A		;Save the param in the C reg whilst the
				;range of the param is tested.
	LD	A,D		;Fetch the original value.
	CP	0AH		;Only allow PAPER/INK a
	JR	C,L2246;CO_TEMP_9 ;range of '0' to '9'.

;Report K - Invalid colour
L2244:;REPORT_K
	RST	8;ERROR_1	;Call the error handling
	DB	13H		;routine.

;Continue to handle PAPER & INK.
L2246:;CO_TEMP_9
	LD	HL,L5C8F	;Prepare to alter ATTR_T, MASK_T & P_FLAG.
	CP	8		;Jump forward with PAPER/INK
	JR	C,L2258;CO_TEMP_B ;'0' to '7'.
	LD	A,(HL)		;Fetch the current value of ATTR_T and use
	JR	Z,L2257;CO_TEMP_A ;it unchanged, by jumping forward,
				;with PAPER/INK '8'.
	OR	B		;But for PAPER/INK '9' the
	CPL			;PAPER and the INK colours
	AND	24h		;have to be black and white.
	JR	Z,L2257;CO_TEMP_A ;Jump for black INK/PAPER; but continue
	LD	A,B		;for white INK/PAPER.
L2257:;CO_TEMP_A
	LD	C,A		;Move the value to the C reg.

;The mask (B) and the value (C) are now used to change ATTR_T.
L2258:;CO_TEMP_B
	LD	A,C		;Move the value.
	CALL	L226C;CO_CHANGE	;Now change ATTR_T as needed.

;Next MASK_T is considered.
	LD	A,7		;The bits of MASK_T are set
	CP	D		;only when using PAPER/INK
	SBC	A,A		;'8' or '9'.
	CALL	L226C;CO_CHANGE	;Now change MASK_T as needed.

;Next P_FLAG is considered.
	RLCA			;The appropriate mask is
	RLCA			;built up in the B reg
	AND	50h		;is order to change bits 4 &
	LD	B,A		;6 as necessary.
	LD	A,8		;The bits of P_FLAG are set only when
	CP	D		;using PAPER/INK '9'.
	SBC	A,A		;Continue into CO_CHANGE
				;to manipulate P_FLAG.

;	THE 'CO_CHANGE' SUBROUTINE
;This subroutine is used to 'impress' upon a system var the 'nature' of the
;bits in the A reg. The B reg holds a mask that shows which bits are to be
;'copied over' from A to (HL).
L226C:;CO_CHANGE
	XOR	(HL)		;The bits, specified by the
	AND	B		;mask in the B reg, are
	XOR	(HL)		;changed in the value and the
	LD	(HL),A		;result goes to form the system var.
	INC	HL		;Move on to addr the next system var.
	LD	A,B		;Return with the mask in the
	RET			;A reg.

;FLASH & BRIGHT are handled by the following routine.
L2273:;CO_TEMP_C
	SBC	A,A		;The zero flag will be set for BRIGHT.
	LD	A,D		;The param is fetched and
	RRCA			;rotated.
	LD	B,80H		;Prepare the mask for FLASH.
	JR	NZ,L227D;CO_TEMP_D ;Jump forward with FLASH.
	RRCA			;Rotate an extra time and
	LD	B,40h		;prepare the mask for BRIGHT.
L227D:;CO_TEMP_D
	LD	C,A		;Save the value in the C reg.
	LD	A,D		;Fetch the param and test
	CP	8		;its range; only '0', '1'
	JR	Z,L2287;CO_TEMP_E ;& '8' are allowed.
	CP	2
	JR	NC,L2244;REPORT_K

;The system var ATTR_T can now be altered.
L2287:;CO_TEMP_E
	LD	A,C		;Fetch the value.
	LD	HL,L5C8F	;This is ATTR_T.
	CALL	L226C;CO_CHANGE	;Now change the system var.

;The value in MASK_T is now considered.
	LD	A,C		;The value is fetched anew.
	RRCA			;The set bit of FLASH/BRIGHT '8' (bit 3)
	RRCA			;is moved to bit 7 (for FLASH) or bit 6
	RRCA			;(for BRIGHT).
	JR	L226C;CO_CHANGE	;Exit via CO_CHANGE.

;	THE 'BORDER' COMMAND ROUTINE
;The parameter of the BORDER command is used with an OUT command to actually
;alter the colour of the border. The parameter is then saved in the system var
;BORDCR.
L2294:;BORDER
	CALL	L1E94;FIND_INT1	;The param is fetched
	CP	8		;and its range is tested.
	JR	NC,L2244;REPORT_K
	OUT	(0FEH),A	;The OUT instruction is then used
				;to set the border colour.
	RLCA			;The parameter is then
	RLCA			;multiplied by eight.
	RLCA
	BIT	5,A		;If the border colour is a 'light' colour
	JR	NZ,L22A6;BORDER_1 ;then the INK colour in the editing area
				;is to be black - make the jump.
	XOR	7		;Change the INK colour.
L22A6:;BORDER_1
	LD	(L5C48),A;BORDCR ;Set the system var as
	RET			;required and return.

